﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace b_nodesigner
{
    public class MyForm : Form
    {
        public MyForm()
        {
            AutoScaleMode = AutoScaleMode.Dpi;
            ClientSize = new(400, 250);
            MinimumSize = new(250, 150);
            StartPosition = FormStartPosition.CenterScreen;
            Text = "Hello Windows Forms!";

            _clickMe = new();
            _clickMe.Text = "Click Me!";
            _clickMe.Location = new(25, 25);
            //or:
            //_clickMe.Left = 25;
            //_clickMe.Top = 25;
            _clickMe.Size = new(350, 200);
            //or:
            //_clickMe.Width = 350;
            //_clickMe.Height = 200;
            _clickMe.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top | AnchorStyles.Bottom;
            _clickMe.Click += (sender, e) => {
                var btnText = (sender as Button)?.Text;
                var title = btnText == null ? "Hi!" : "Hi " + btnText;
                MessageBox.Show(this, "Good day to you!", title, MessageBoxButtons.OK);
            };
            Controls.Add(_clickMe);
        }

        Button _clickMe;
    }
}
