﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace d_controls
{
    public partial class ALabels : Form
    {
        public ALabels(Form owner)
        {
            InitializeComponent();
            Owner = owner;
            //Commented lines of code are exerpts from InitializeComponents,
            //demonstrating some properties set by the visual designer

            //Set the label text
            //lblWImage.Text = "Programming in Graphical Environment";
            //and it's alignment within the label area
            //lblWImage.TextAlign = ContentAlignment.MiddleRight;

            //Set the label image
            //lblWImage.Image = Properties.Resources.PiGE;
            //and it's alignment within the label area
            //lblWImage.ImageAlign = ContentAlignment.MiddleLeft;

            //Placing & before a letter 'E' in label text associates a shortcut Alt+E with it
            //lblTextBox.Text = "&Enter Text";
            //Label by default doesn't receive focus, but when shortcut is pressed, focus jumps to the control
            //with the next tab index
            //lblTextBox.TabIndex = 1;
            //Label's tab index is 1, so the textbox we want to associate with it has it set to 2
            //tbText.TabIndex = 2;

            //Link Label can receive focus, so Alt+O should select it
            //llblNotepad.Text = "&Open Notepad";
            //Link Label has properties that apply to it as a whole:
            //llblNotepad.LinkVisited = false;
            //But in fact, Link label contains a collection of one or more separate links. By default the only link is
            //formed from the entire link label text, but that can be changed:
            //llblFolder.LinkArea = new LinkArea(12/*starting index of the link substring*/, 4/*length of the link substring*/);

            //Each link has properties of it's own, that can be set independently. Those, however, are not available
            //in the designer and need to be set from code:
            llblNotepad.Links[0].LinkData = "notepad.exe";
            llblNotepad.Links[0].Description = "Opens notepad";
            llblNotepad.Links[0].Visited = false;
            llblWeb.Links[0].LinkData = "https://learn.microsoft.com/";
            llblFolder.Links[0].LinkData = "C:\\";

            //Additional links need to be added manually, specifying starting position and length in the link lable's text
            llblFolder.Links.Add(19, 3, "D:\\");
            llblFolder.Links.Add(27, 3, "E:\\");
            llblFolder.Links[2].Enabled = false;

            //Link label has a Clicked event (inherited from Control), but Link Label specific LinkClicked event
            //provides us with additional arguments: the particular link that was clicked and which mouse button was
            //used to click it
            //llblNotepad.LinkClicked += OnVisit;
        }

        private void OnVisit(object sender, LinkLabelLinkClickedEventArgs e)
        {
            var command = e.Link?.LinkData as string;
            if (command != null && e.Button == MouseButtons.Left)
            {
                Process.Start(new ProcessStartInfo(command) { UseShellExecute = true });
                e.Link!.Visited = true;
            }
        }

        private void HideForm(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.FormOwnerClosing)
            {
                Hide();
                e.Cancel = true;
            }
        }
    }
}
