﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace d_controls
{
    public partial class CButtons : Form
    {
        public CButtons(Form owner)
        {
            InitializeComponent();
            Owner = owner;
            rbtnRed.Tag = Color.Red;
            rbtnGreen.Tag = Color.Green;
            rbtnBlue.Tag = Color.Blue;
            rbtnYellow.Tag = Color.Yellow;
            rbtnBold.Tag = FontStyle.Bold;
            rbtnItalic.Tag = FontStyle.Italic;
        }

        private void OnFontStyleChange(object sender, EventArgs e)
        {
            var rbtn = (sender as RadioButton);
            if (rbtn == null || !rbtn.Checked || rbtn.Tag is not FontStyle)
                return;
            btnClick.Font = new(btnClick.Font, (FontStyle)rbtn.Tag);
        }

        private void OnColorChange(object sender, EventArgs e)
        {
            var rbtn = (sender as RadioButton);
            if (rbtn == null || !rbtn.Checked || rbtn.Tag is not Color)
                return;
            btnClick.ForeColor = (Color)rbtn.Tag;
        }

        private void HideForm(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.FormOwnerClosing)
            {
                Hide();
                e.Cancel = true;
            }
        }
    }
}
